recursive function CalcBulkEnth(Tempr,Presr,Salin) Result(Answer)
! Note: returns -1 if there is an error

use CommonVars, only: EnthSlices,Prec
implicit none
real(selected_real_kind(Prec)) :: Answer,Tempr,Presr,Salin,    &
   S3PhaseL,Pres3Ph,Pres3Phase,Interp3D,T1,T2,H1,H2,Slope,     &
   SlopeT2,T21,T22,S1,S2,CritiPres,TempFrac,Modulator,Mod1,    &
   Mod2,ModSlope,SolubilityV,T11,T12,SlopeT1,S2PhaseL
integer :: PhaseIndex,PhaseInd

PhaseInd = PhaseIndex(Tempr,Presr,Salin)
if (PhaseInd.ne.-100) then
   T11 = 290.D0
   T12 = 250.D0
   T21 = 310.D0
   T22 = 350.D0
   SlopeT1 = (T12-T11)/100.D-2
   SlopeT2 = (T22-T21)/100.D-2
   T1 = SlopeT1*Salin+T11
   T2 = SlopeT2*Salin+T21
   if ((Tempr>T1).and.(Tempr<T2)) then
      H1 = CalcBulkEnth(T1,Presr,Salin)
      H2 = CalcBulkEnth(T2,Presr,Salin)
      Slope = (H2-H1)/(T2-T1)
      Answer = Slope*(Tempr-T1)+H1
   elseif (PhaseInd==-2) then
      Answer = Interp3D(Tempr,Presr,S3PhaseL(Tempr), &
                        EnthSlices)*1.D3
   elseif (PhaseInd==2) then
      Answer = Interp3D(Tempr,Presr,SolubilityV(Tempr,Presr), &
               EnthSlices)*1.D3
   else
      Answer = Interp3D(Tempr,Presr,Salin,EnthSlices)*1.D3
   end if
else
   Answer = -1.D0
end if

end
