function CalcDRhoDPres(Tempr,Presr,Salin) Result(Answer)

use CommonVars, only: Prec,LogFile,MinPres,MaxPres
implicit none
real (selected_real_kind(Prec)) :: DeltaP,Pres1,Pres2,Dens1,Dens2,   &
   CalcBulkDens,Tempr,Presr,Salin,Answer

DeltaP = 0.5*1.D-2
Pres1 = MAX(MinPres,Presr-DeltaP)
Pres2 = MIN(MaxPres,Presr+DeltaP)

Dens1 = CalcBulkDens(Tempr,Pres1,Salin)
Dens2 = CalcBulkDens(Tempr,Pres2,Salin)
if ((Dens1==-1.D0).or.(Dens2==-1.D0)) then
   write(LogFile,*) 'Problem computing density derivative'
   write(LogFile,*) '-CalcDRhoDPres'
   write(LogFile,*) 'Halting'
   stop
end if
Answer=DABS((Dens2-Dens1)/(Pres2-Pres1))

end 
