function CalcDRhoDSali(Tempr,Presr,Salin) Result(Answer)

use CommonVars, only: Prec,LogFile,MinSali,MaxSali
implicit none
real (selected_real_kind(Prec)) :: DeltaX,Sali1,Sali2,Dens1,Dens2,   &
   CalcBulkDens,Tempr,Presr,Salin,Answer

DeltaX = 0.5*1.D-5
Sali1 = MAX(MinSali,Salin-DeltaX)
Sali2 = MIN(MaxSali,Salin+DeltaX)

Dens1 = CalcBulkDens(Tempr,Presr,Sali1)
Dens2 = CalcBulkDens(Tempr,Presr,Sali2)
if ((Dens1==-1.D0).or.(Dens2==-1.D0)) then
   write(LogFile,*) 'Problem computing density derivative'
   write(LogFile,*) '-CalcDRhoDSali'
   write(LogFile,*) 'Halting'
   stop
end if
Answer=DABS((Dens2-Dens1)/(Sali2-Sali1))

end 
