function CalcDRhoDTemp(Tempr,Presr,Salin) Result(Answer)

use CommonVars, only: Prec,LogFile,MinTemp,MaxTemp
implicit none
real (selected_real_kind(Prec)) :: DeltaT,Temp1,Temp2,Dens1,Dens2,   &
   CalcBulkDens,Tempr,Presr,Salin,Answer

DeltaT = 0.5*1.D-4
Temp1 = MAX(MinTemp,Tempr-DeltaT)
Temp2 = MIN(MaxTemp,Tempr+DeltaT)

Dens1 = CalcBulkDens(Temp1,Presr,Salin)
Dens2 = CalcBulkDens(Temp2,Presr,Salin)
if ((Dens1==-1.D0).or.(Dens2==-1.D0)) then
   write(LogFile,*) 'Problem computing density derivative'
   write(LogFile,*) '-CalcDRhoDTemp'
   write(LogFile,*) 'Halting'
   stop
end if
Answer=-DABS((Dens2-Dens1)/(Temp2-Temp1))

end 
