function D2PhaseV(Tempr,Presr)
! Input: temperature (C), pressure (Pa)
! Output: density (kg/m^3) on the vapor side of the upper boundary
! of the two-phase region.

use CommonVars, only:Prec
implicit none
real (selected_real_kind(Prec)) :: Tempr,Presr,D2PhaseV,CritiPres, &
   CritPresr,Pres3Phase,Pres3Ph

CritPresr = CritiPres(Tempr)
Pres3Ph   = Pres3Phase(Tempr)
if (Presr > CritPresr) then
   call Base2Phase(Tempr,CritPresr,'B',D2PhaseV)
else if (Presr < Pres3Ph) then
   call Base2Phase(Tempr,Pres3Ph,'B',D2PhaseV)
else
   call Base2Phase(Tempr,Presr,'B',D2PhaseV)
end if

return
end
!*********************************************************************
function D2PhaseL(Tempr,Presr)
! Input: temperature (C), pressure (Pa)
! Output: density (kg/m^3) on the liquid side of the upper boundary
! of the two-phase region.

use CommonVars, only:Prec
implicit none
real (selected_real_kind(Prec)) :: Tempr,Presr,D2PhaseL,CritiPres, &
   CritPresr,Pres3Phase,Pres3Ph

CritPresr = CritiPres(Tempr)
Pres3Ph   = Pres3Phase(Tempr)
if (Presr > CritPresr) then
   call Base2Phase(Tempr,CritPresr,'A',D2PhaseL)
else if (Presr < Pres3Ph) then
   call Base2Phase(Tempr,Pres3Ph,'A',D2PhaseL)
else
   call Base2Phase(Tempr,Presr,'A',D2PhaseL)
end if

return
end 
