function EnergyError(I,J,K)

use CommonVars, only: Prec,PrevEnergy,XNodeWidths,YNodeWidths,       &
   ZNodeWidths,Temp,Pres,Sali,Porosities,CpRock,RockDens,            &
   TempNodeTypes,DeltaEnergyLocal
implicit none
real(selected_real_kind(Prec)) :: EnergyError,EnergyIn,TotalVolume,  &
   Dens,CurrentEnergy,CalcBulkDens,EnergyGain,Enth,CalcBulkEnth
integer :: I,J,K

TotalVolume = XNodeWidths(I)*YNodeWidths(J)*ZNodeWidths(K)
Dens = CalcBulkDens(Temp(I,J,K),Pres(I,J,K),Sali(I,J,K))
Enth = CalcBulkEnth(Temp(I,J,K),Pres(I,J,K),Sali(I,J,K))
CurrentEnergy = Enth*Porosities(I,J,K)*Dens*TotalVolume+ &
   (1.D0-Porosities(I,J,K))*RockDens*CpRock* &
   Temp(I,J,K)*TotalVolume

EnergyGain = CurrentEnergy-PrevEnergy(I,J,K)
if (TempNodeTypes(I,J,K)=='U') then
   EnergyError = 0.D0
   DeltaEnergyLocal(I,J,K) = 0.D0
else
   EnergyError = DABS(EnergyGain-EnergyIn(I,J,K))/PrevEnergy(I,J,K)
   DeltaEnergyLocal(I,J,K) = EnergyIn(I,J,K)-EnergyGain
end if

end
