function EnergyIn(I,J,K) Result(Answer)

use CommonVars, only: Prec,XNodeWidths,YNodeWidths,ZNodeWidths,      &
   Pres,Sali,RockDens,CpRock,Porosities,Delta_t,XInterfHeatFlux,     &
   ZInterfHeatFlux,XInterfPoros,ZInterfPoros,FluidThermCond,         &
   RockThermCond,TempNodeTypes,TempBoundVals,NumNodesX,NumNodesZ,    &
   Temp
implicit none
real(selected_real_kind(Prec)) :: Answer,CrossArea,NodeDistance,     &
   KMedium,EnergyInWest,EnergyInEast,EnergyInTop,EnergyInBot,        &
   EnergyDiffWest,EnergyDiffEast,EnergyDiffTop,EnergyDiffBot,        &
   CurrentEnergyIn,EnergyErr
integer :: I,J,K

if ((I<1).or.(I>NumNodesX).or.(K<1).or.(K>NumNodesZ)) then
   Answer = 0.D0
else
!----------
CrossArea = YNodeWidths(J)*ZNodeWidths(K)
if (I > 1) then
   NodeDistance = (XNodeWidths(I)+XNodeWidths(I-1))/2.D0
   EnergyInWest = XInterfHeatFlux(I-1,J,K)*CrossArea*Delta_t
   KMedium=XInterfPoros(I-1,1,K)*FluidThermCond + &
      (1.D0-XInterfPoros(I-1,1,K))*RockThermCond
   EnergyDiffWest = -(KMedium*(Temp(I,J,K)-Temp(I-1,J,K))/ &
                      NodeDistance)*CrossArea*Delta_t
else
   if (TempNodeTypes(I,J,K)=='F') then
      EnergyInWest = TempBoundVals(I,J,K)*CrossArea*Delta_t
      EnergyDiffWest = 0.D0
   else
      EnergyInWest = 0.D0
      EnergyDiffWest = 0.D0
   end if
end if
if (I < NumNodesX) then
   NodeDistance = (XNodeWidths(I)+XNodeWidths(I+1))/2.D0
   EnergyInEast = -XInterfHeatFlux(I,J,K)*CrossArea*Delta_t
   KMedium=XInterfPoros(I,1,K)*FluidThermCond + &
      (1.D0-XInterfPoros(I,1,K))*RockThermCond
   EnergyDiffEast = (KMedium*(Temp(I+1,J,K)-Temp(I,J,K))/ &
                     NodeDistance)*CrossArea*Delta_t
else
   if (TempNodeTypes(I,J,K)=='F') then
      EnergyInEast = TempBoundVals(I,J,K)*CrossArea*Delta_t
      EnergyDiffEast = 0.D0
   else
      EnergyInEast = 0.D0
      EnergyDiffEast = 0.D0
   end if
end if

CrossArea  = YNodeWidths(J)*XNodeWidths(I)
if (K > 1) then
   NodeDistance = (ZNodeWidths(K)+ZNodeWidths(K-1))/2.D0
   EnergyInTop = ZInterfHeatFlux(I,J,K-1)*CrossArea*Delta_t
   KMedium=ZInterfPoros(I,1,K-1)*FluidThermCond + &
      (1.D0-ZInterfPoros(I,1,K-1))*RockThermCond
   EnergyDiffTop = -(KMedium*(Temp(I,J,K)-Temp(I,J,K-1))/ &
                     NodeDistance)*CrossArea*Delta_t
else
   if (TempNodeTypes(I,J,K)=='F') then
      EnergyInTop = TempBoundVals(I,J,K)*CrossArea*Delta_t
      EnergyDiffTop = 0.D0
   else
      EnergyInTop = 0.D0
      EnergyDiffTop = 0.D0
   end if
end if
if (K < NumNodesZ) then
   NodeDistance = (ZNodeWidths(K)+ZNodeWidths(K+1))/2.D0
   EnergyInBot = -ZInterfHeatFlux(I,J,K)*CrossArea*Delta_t
   KMedium=ZInterfPoros(I,1,K)*FluidThermCond + &
      (1.D0-ZInterfPoros(I,1,K))*RockThermCond
   EnergyDiffBot = (KMedium*(Temp(I,J,K+1)-Temp(I,J,K))/ &
                    NodeDistance)*CrossArea*Delta_t
else
   if (TempNodeTypes(I,J,K)=='F') then
      EnergyInBot = TempBoundVals(I,J,K)*CrossArea*Delta_t
      EnergyDiffBot = 0.D0
   else
      EnergyInBot = 0.D0
      EnergyDiffBot = 0.D0
   end if
end if

CurrentEnergyIn = EnergyInWest + EnergyInEast + EnergyInTop + &
   EnergyInBot + EnergyDiffWest + EnergyDiffEast + &
   EnergyDiffTop + EnergyDiffBot
Answer = CurrentEnergyIn
!----------
end if
end
