subroutine EnergyTrackGlobal(InitVars)

use CommonVars, only: NumNodesZ,ZInterfHeatFlux,EnergyInTop,         &
   InitSystemEnergy,FinlSystemEnergy,ZNodeWidths,XNodeWidths,        &
   YNodeWidths,BulkDens,Sali,Delta_t,Prec,Porosities,Time,           &
   EnergyInBot,EnergyInWest,EnergyInEast,NumNodesX,XInterfHeatFlux,  &
   TimeStepCheck,TimeStepFlag,NumTimeCuts,MaxTimeCuts,LogFile,       &
   GlobalEnergyTol,StepNum,Pres,Temp,LastPrintTime,PrintFreq,        &
   DeltaEnergyGlobal,GlobalEnergyError,TempNodeTypes,TempBoundVals,  &
   EnergyDiffTop,EnergyDiffBot,EnergyDiffWest,EnergyDiffEast,CpRock, &
   RockDens,BulkEnth,FluidThermCond,RockThermCond,ZInterfPoros,      &
   XInterfPoros
implicit none
real(selected_real_kind(Prec)) :: TotalEnergyIn,EnergyGain,tInYears, &
   EnergyError,TotalVolume,CalcBulkDens,KMedium,NodeDistance,        &
   CalcBulkEnth
integer :: PrintStep,InitVars,I,K

if (InitVars==1) then
   GlobalEnergyTol = 5.D0
   open(unit=14,file='EnergyTrackGlobal.dat',status='replace')
   close(14)
   EnergyInTop  = 0.D0
   EnergyInBot  = 0.D0
   EnergyInWest = 0.D0
   EnergyInEast = 0.D0
   InitSystemEnergy = 0.D0
   do K=1,NumNodesZ
      do I=1,NumNodesX
         if ((TempNodeTypes(I,1,K).ne.'U').and. &
            (TempNodeTypes(I,1,K).ne.'C')) then
            TotalVolume = XNodeWidths(I)*YNodeWidths(1)*ZNodeWidths(K)
            InitSystemEnergy = InitSystemEnergy + BulkDens(I,1,K)*   &
               BulkEnth(I,1,K)*TotalVolume*Porosities(I,1,K) +       &
               (1.D0-Porosities(I,1,K))*RockDens*CpRock*Temp(I,1,K)* &
               TotalVolume
         end if
      end do
   end do
else
   FinlSystemEnergy = 0.D0
   do K=1,NumNodesZ
      do I=1,NumNodesX
         if ((TempNodeTypes(I,1,K).ne.'U').and. &
            (TempNodeTypes(I,1,K).ne.'C')) then
            TotalVolume = XNodeWidths(I)*YNodeWidths(1)*ZNodeWidths(K)
            FinlSystemEnergy = FinlSystemEnergy + &
               CalcBulkDens(Temp(I,1,K),Pres(I,1,K),Sali(I,1,K))* &
               CalcBulkEnth(Temp(I,1,K),Pres(I,1,K),Sali(I,1,K))* &
               TotalVolume*Porosities(I,1,K)+(1.D0-Porosities(I,1,K))* &
               RockDens*CpRock*Temp(I,1,K)*TotalVolume
         end if
         if (I>1) then
            if ((TempNodeTypes(I-1,1,K)=='U').or. &
               (TempNodeTypes(I-1,1,K)=='C')) then
               EnergyInWest = EnergyInWest + &
                  XInterfHeatFlux(I-1,1,K)*Delta_t* &
                  ZNodeWidths(K)*YNodeWidths(1)
               NodeDistance = (XNodeWidths(I-1)+XNodeWidths(I))/2.D0
               KMedium=XInterfPoros(I-1,1,K)*FluidThermCond + &
                  (1.D0-XInterfPoros(I-1,1,K))*RockThermCond
               EnergyDiffWest = EnergyDiffWest - &
                  (KMedium*(Temp(I,1,K)-Temp(I-1,1,K))/  &
                  NodeDistance)*ZNodeWidths(K)*Delta_t
            elseif (TempNodeTypes(I-1,1,K)=='F') then
               if ((K.ne.1).and.(K.ne.NumNodesZ)) then
                  EnergyInWest = EnergyInWest + TempBoundVals(I-1,1,K)* &
                     ZNodeWidths(K)*Delta_t
               end if
            end if
         end if
         if (I<NumNodesX) then
            if ((TempNodeTypes(I+1,1,K)=='U').or. &
               (TempNodeTypes(I+1,1,K)=='C')) then
               EnergyInEast = EnergyInEast - &
                  XInterfHeatFlux(I,1,K)*Delta_t* &
                  ZNodeWidths(K)*YNodeWidths(1)
               NodeDistance = (XNodeWidths(I)+XNodeWidths(I+1))/2.D0
               KMedium=XInterfPoros(I,1,K)*FluidThermCond + &
                  (1.D0-XInterfPoros(I,1,K))*RockThermCond
               EnergyDiffEast = EnergyDiffEast + &
                  (KMedium*(Temp(I+1,1,K)-Temp(I,1,K))/ &
                  NodeDistance)*ZNodeWidths(K)*Delta_t
            elseif (TempNodeTypes(I+1,1,K)=='F') then
               if ((K.ne.1).and.(K.ne.NumNodesZ)) then
                  EnergyInEast = EnergyInEast + TempBoundVals(I+1,1,K)* &
                     ZNodeWidths(K)*Delta_t
               end if
            end if
         end if
         if (K>1) then
            if ((TempNodeTypes(I,1,K-1)=='U').or. &
               (TempNodeTypes(I,1,K-1)=='C')) then
               EnergyInTop = EnergyInTop + &
                  ZInterfHeatFlux(I,1,K-1)*Delta_t* &
                  XNodeWidths(I)*YNodeWidths(1)
               NodeDistance = (ZNodeWidths(K-1)+ZNodeWidths(K))/2.D0
               KMedium=ZInterfPoros(I,1,K-1)*FluidThermCond + &
                  (1.D0-ZInterfPoros(I,1,K-1))*RockThermCond
               EnergyDiffTop = EnergyDiffTop - &
                  (KMedium*(Temp(I,1,K)-Temp(I,1,K-1))/ &
                  NodeDistance)*XNodeWidths(I)*Delta_t
            elseif (TempNodeTypes(I,1,K-1)=='F') then
               EnergyInTop = EnergyInTop + TempBoundVals(I,1,K-1)* &
                  XNodeWidths(I)*Delta_t
            end if
         end if
         if (K<NumNodesZ) then
            if ((TempNodeTypes(I,1,K+1)=='U').or. &
               (TempNodeTypes(I,1,K+1)=='C')) then
               EnergyInBot = EnergyInBot - &
                  ZInterfHeatFlux(I,1,K)*Delta_t*   &
                  XNodeWidths(I)*YNodeWidths(1)
               NodeDistance = (ZNodeWidths(K+1)+ZNodeWidths(K))/2.D0
               KMedium=ZInterfPoros(I,1,K)*FluidThermCond + &
                  (1.D0-ZInterfPoros(I,1,K))*RockThermCond
               EnergyDiffBot = EnergyDiffBot + &
                  (KMedium*(Temp(I,1,K+1)-Temp(I,1,K))/ &
                  NodeDistance)*XNodeWidths(I)*Delta_t
            elseif (TempNodeTypes(I,1,K+1)=='F') then
               EnergyInBot = EnergyInBot + TempBoundVals(I,1,K+1)* &
                  XNodeWidths(I)*Delta_t
            end if
         end if
      end do
   end do
   TotalEnergyIn = &
      EnergyInTop + EnergyInBot + EnergyInWest + EnergyInEast + &
      EnergyDiffTop+EnergyDiffBot+EnergyDiffWest+EnergyDiffEast
   EnergyGain = FinlSystemEnergy - InitSystemEnergy
   EnergyError = DABS(EnergyGain-TotalEnergyIn)
   DeltaEnergyGlobal = TotalEnergyIn-EnergyGain
   EnergyError = 100.D0*EnergyError/InitSystemEnergy
   GlobalEnergyError = EnergyError/100.D0

   !write(*,*) 'Global energy error: ',EnergyError

   if ((TimeStepCheck == 'Y').and.(TimeStepFlag == 0)) then
      if (EnergyError > GlobalEnergyTol) then
         if ((NumTimeCuts < MaxTimeCuts).and.(StepNum>0)) then
            if (EnergyError > GlobalEnergyTol) then
               write(LogFile,*) 'Global energy percent error too large:', &
                  EnergyError,'%'
            end if
            TimeStepFlag = 1
            GlobalEnergyTol = GlobalEnergyTol + GlobalEnergyTol
         end if
      end if
   end if
   if ((Time-LastPrintTime)>=PrintFreq) then
      PrintStep = 1
   else
      PrintStep = 0
   end if
   if (PrintStep==1) then
      open(unit=14,file='EnergyTrackGlobal.dat',status='old',position='append')
      tInYears = real(Time*(1.D0/3600.D0)*(1.D0/24.D0)*(1.D0/365.25D0))
      write(14,*) '-----------------------------------------------------'
      write(14,*) 'Printing output at time = ',tInYears,' yrs'
      write(14,*) '-----------------------------------------------------'
      write(14,*) 'initial system energy energy (J): ', InitSystemEnergy
      write(14,*)
      write(14,*) 'final system energy energy: ', FinlSystemEnergy
      write(14,*)
      write(14,*) 'total energy into the system: ',TotalEnergyIn
      write(14,*)
      write(14,*) 'total system energy gain: ',EnergyGain
      write(14,*)
      write(14,*) 'energy error as percent of total energy: ',EnergyError,'%'
      close(14)
   end if
end if

end
