subroutine EnergyTrackLocal(InitVars)

use CommonVars, only: Prec,PrevEnergy,BulkEnth,Porosities,           &
   XNodeWidths,YNodeWidths,ZNodeWidths,XInterfHeatFlux,              &
   ZInterfHeatFlux,Delta_t,NumNodesX,NumNodesZ,OldPres,NumNodesY,    &
   Time,TimeStepCheck,Delta_t,TimeStepFlag,NumTimeCuts,MaxTimeCuts,  &
   LogFile,Temp,RockDens,CpRock,BulkDens,RockThermCond,EnergyErrNum, &
   TempNodeTypes,TempBoundVals,StepNum,PhaseIndices,StepNum,Pres,    &
   Sali,XInterfPoros,ZInterfPoros,FluidThermCond,EnergyTol,          &
   LocalEnergyError,DeltaEnergyLocal
implicit none
real(selected_real_kind(Prec)) :: CurrentEnergy,TotalVolume,         &
   EnergyIncrease,tInYears,EnergyErr,MaxEnergyError,CalcBulkEnth,    &
   KMedium,CalcBulkDens,EnergyError
integer :: InitVars,I,J,K,TotalNodes,MaxEnergyErrorLoc(3),           &
   UpstreamBnd,CheckUpstream

MaxEnergyError = 0.D0
if (InitVars == 1) then
   EnergyErrNum = 0
   LocalEnergyError = 0.D0
   do I=1,NumNodesX
      do J=1,NumNodesY
         do K=1,NumNodesZ
            TotalVolume = XNodeWidths(I)*YNodeWidths(J)*ZNodeWidths(K)
            PrevEnergy(I,J,K) = BulkEnth(I,J,K)*Porosities(I,J,K)* &
               BulkDens(I,J,K)*TotalVolume + &
               (1.D0-Porosities(I,J,K))*RockDens*CpRock*Temp(I,J,K)* &
               TotalVolume
            DeltaEnergyLocal(I,J,K) = 0.D0
         end do
      end do
   end do
else
!---------------------------------------------------------------------
do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         TotalVolume = XNodeWidths(I)*YNodeWidths(J)*ZNodeWidths(K)
         CurrentEnergy = CalcBulkEnth(Temp(I,J,K),Pres(I,J,K), &
            Sali(I,J,K))*Porosities(I,J,K)* &
            CalcBulkDens(Temp(I,J,K),Pres(I,J,K),Sali(I,J,K))* &
            TotalVolume+(1.D0-Porosities(I,J,K))*RockDens*CpRock* &
            Temp(I,J,K)*TotalVolume

         EnergyErr = 100.D0*EnergyError(I,J,K)

         UpstreamBnd = CheckUpstream(I,J,K)

         if (EnergyErr > MaxEnergyError) then
            if (UpstreamBnd==0) then
               MaxEnergyError = EnergyErr
               MaxEnergyErrorLoc(1) = I
               MaxEnergyErrorLoc(2) = J
               MaxEnergyErrorLoc(3) = K
            end if
         end if

         PrevEnergy(I,J,K) = CurrentEnergy
      end do
   end do
end do
LocalEnergyError = MaxEnergyError
if ((TimeStepCheck == 'Y').and.(TimeStepFlag == 0)) then
   I = MaxEnergyErrorLoc(1)
   J = 1
   K = MaxEnergyErrorLoc(3)
   !write(*,*) 'MaxEnergyError: ',MaxEnergyError,I,J,K
   if ((MaxEnergyError > EnergyTol).and.(StepNum>0)) then
      EnergyErrNum = EnergyErrNum + 1
      if (EnergyErrNum >= 1) then
         write(LogFile,*) 'Energy percent error too large:', &
           MaxEnergyError,'%'
         TimeStepFlag = 1
         EnergyErrNum = 0
      end if
   else
      EnergyErrNum = 0
   end if
end if
!---------------------------------------------------------------------
end if
end
