subroutine FindPres1Ph(Presr,r1,r2)
! Purpose: to locate the pressure within PresArray as part 
!          of the procedure to interpolate between values 
!          of density and enthalpy in the 3D lookup tables 
!          DensSlices and EnthSlices.
! Input: pressure (Pa)
! Output: rows r1 and r2 such that 
! PresArray(r1) <= Presr/1.D5 <= PresArray(r2) 

use CommonVars, only: Prec,PresArray
implicit none
real (selected_real_kind(Prec)) :: Presr, Avg, Pi, Pf, Pm
integer :: r1, r2, ri, rf, rm, Flag

Presr = Presr/1.D5
Flag = 0
ri = 1
rf = 200
Avg = (ri+rf)/2
rm = IDNINT(avg)
Pi = PresArray(ri)
Pf = PresArray(rf)
Pm = PresArray(rm)
do while (Flag.NE.1)
   if ((Presr>=Pi).AND.(Presr<=Pm)) then
      rf = rm
      Avg = (ri+rf)/2
      rm = IDNINT(avg)
      Pf = PresArray(rf)
      Pm = PresArray(rm)
      if ((rm.EQ.ri).OR.(rm.EQ.rf)) then
         Flag = 1
      end if
   else
      ri = rm
      Avg = (ri+rf)/2
      rm = IDNINT(avg)
      Pi = PresArray(ri)
      Pm = PresArray(rm)
      if ((rm.EQ.ri).OR.(rm.EQ.rf)) then
         flag = 1
      end if
   end if
end do
Presr = Presr*1.D5
r1 = ri
r2 = rf
end
