subroutine FindSali1Ph(Salin,r1,r2)
! Purpose: to locate the salinity within SaliArray as part 
!          of the procedure to interpolate between values 
!          of density and enthalpy in the 3D lookup tables 
!          DensSlices and EnthSlices.
! Input: pressure (Pa)
! Output: rows r1 and r2 such that 
! SaliArray(r1) <= Sali*1.D2 <= SaliArray(r2) 

use CommonVars, only: Prec,SaliArray
implicit none
real (selected_real_kind(Prec)) :: Salin, Avg, Si, Sf, Sm
integer :: r1, r2, ri, rf, rm, Flag

Salin = Salin*1.D2
Flag = 0
ri = 1
rf = 100
Avg = (ri+rf)/2
rm = IDNINT(avg)
Si = SaliArray(ri)
Sf = SaliArray(rf)
Sm = SaliArray(rm)
do while (Flag.NE.1)
   if ((Salin>=Si).AND.(Salin<=Sm)) then
      rf = rm
      Avg = (ri+rf)/2
      rm = IDNINT(avg)
      Sf = SaliArray(rf)
      Sm = SaliArray(rm)
      if ((rm.EQ.ri).OR.(rm.EQ.rf)) then
         Flag = 1
      end if
   else
      ri = rm
      Avg = (ri+rf)/2
      rm = IDNINT(avg)
      Si = SaliArray(ri)
      Sm = SaliArray(rm)
      if ((rm.EQ.ri).OR.(rm.EQ.rf)) then
         flag = 1
      end if
   end if
end do
Salin = Salin/1.D2
r1 = ri
r2 = rf
end
