subroutine Get2PhaseResult(Row,Col,Choice,Answer)
! Purpose: Returns the parameter of choice located at the
!          designated row and column of the appropriate
!          matrix holding values of that parameter on the
!          upper boundary of the two-phase region.
! Input: Row and Column of the desired parameter in the
!        matrix, and the matrix from which to retrieve
!        the paramater: Choice is a character from A to F:
!        A - liquid density
!        B - vapor density
!        C - liquid salinity
!        D - vapor salinity
! Output: Answer, the value of the chosen parameter on the
!         upper boundary of the two-phase region

use CommonVars, only: Prec,LiqDens2Ph,LiqSali2Ph,VapDens2Ph, &
   VapSali2Ph
implicit none
real (selected_real_kind(Prec)) :: Answer
integer :: Row,Col
character :: Choice

if (Choice=='A') then
   Answer = LiqDens2Ph(Row,Col)
elseif (Choice=='B') then
   Answer = VapDens2Ph(Row,Col)
elseif (Choice=='C') then
   Answer = LiqSali2Ph(Row,Col)/100.D0
elseif (Choice=='D') then
   Answer = VapSali2Ph(Row,Col)/100.D0
end if

end
