subroutine GetPhaseIndices(PhaseChange)
! Purpose: to decide and store the phase index for each node.
!          The phases are identified numerically as follows:
!          -2 = liquid-halite
!          -1 = liquid
!           0 = liquid-vapor 
!           1 = vapor
!           2 = vapor-halite

use CommonVars, only:PhaseIndices,NumNodesX,NumNodesY,NumNodesZ, Prec, &
                Temp,Sali,Pres,LogFile
implicit none
integer :: I,J,K,PhaseIndex,OldIndex,PhaseChange
real (selected_real_kind(Prec)) :: Tempr,Presr,Salin

PhaseChange = 0
do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         Tempr = Temp(I,J,K)
         Presr = Pres(I,J,K)
         Salin = Sali(I,J,K)
         OldIndex = PhaseIndices(I,J,K)
         PhaseIndices(I,J,K) = PhaseIndex(Tempr,Presr,Salin)
         if (OldIndex /= PhaseIndices(I,J,K)) then
            PhaseChange = 1
         end if
      end do
   end do
end do

end
