function H2PhaseV(Tempr,Presr)
! Input: temperature (C), pressure (Pa)
! Output: enthalpy (J/kg) on the vapor side of the upper boundary
! of the two-phase region.

use CommonVars, only: Prec
implicit none
real(selected_real_kind(Prec)) :: Tempr,Presr,H2PhaseV,S2PhaseV, &
   CalcBulkEnth

H2PhaseV = CalcBulkEnth(Tempr,Presr,S2PhaseV(Tempr,Presr))

end
!----------------------------------------------------------
function H2PhaseL(Tempr,Presr)
! Input: temperature (C), pressure (Pa)
! Output: enthalpy (J/kg) on the vapor side of the upper boundary
! of the two-phase region.

use CommonVars, only: Prec
implicit none
real(selected_real_kind(Prec)) :: Tempr,Presr,H2PhaseL,S2PhaseL, &
   CalcBulkEnth

H2PhaseL = CalcBulkEnth(Tempr,Presr,S2PhaseL(Tempr,Presr))

end
