function HarmonicMean(ArgP,ArgAdj,RelInterfPos)
! Purpose: To calculate the harmonic mean of the input values.
! Input: ArgP is the value of whatever parameter at the node P, 
!        and ArgAdj is the value of whatever parameter at the
!        adjacent node. RelInterfPos is the fraction of the distance 
!        of the interface from the current node to the adjacent one.
! Output: The harmonic mean of the input parameters.

use CommonVars, only:Prec
implicit none
real (selected_real_kind(Prec)) :: ArgP,ArgAdj,RelInterfPos, &
                                   HarmonicMean,Term1,Term2

Term1 = RelInterfPos/ArgP
Term2 = (1.D0-RelInterfPos)/ArgAdj
HarmonicMean = 1.D0/(Term1+Term2)

end 
