subroutine InterfMassFlux

use CommonVars, only: Prec,NumNodesX,NumNodesY,NumNodesZ,LiqVelocX, &
   VapVelocX,LiqVelocZ,VapVelocZ,XInterfLiqDens,XInterfVapDens,     &
   ZInterfLiqDens,ZInterfVapDens,XInterfMassFlux,ZInterfMassFlux,   &
   SaliNodeTypes
implicit none
integer :: I,J,K

!--------------------------------------------------------------------
! mass fluxes in the x direction
!--------------------------------------------------------------------
do I=1,NumNodesX-1
   do J=1,NumNodesY
      do K=1,NumNodesZ
         XInterfMassFlux(I,J,K) = &
            XInterfLiqDens(I,J,K)*LiqVelocX(I,J,K) + &
            XInterfVapDens(I,J,K)*VapVelocX(I,J,K)
      end do
   end do
end do
!--------------------------------------------------------------------
! mass fluxes in the z direction
!--------------------------------------------------------------------
do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ-1
         ZInterfMassFlux(I,J,K) = &
            ZInterfLiqDens(I,J,K)*LiqVelocZ(I,J,K) + &
            ZInterfVapDens(I,J,K)*VapVelocZ(I,J,K)
      end do
   end do
end do

end
