function MassIn(I,J,K)

use CommonVars, only: Prec,XNodeWidths,YNodeWidths,ZNodeWidths,      &
   PrevMass,Porosities,Delta_t,XInterfMassFlux,ZInterfMassFlux,      &
   PresNodeTypes,PresBoundVals,NumNodesX,NumNodesZ,Temp,Pres,Sali
implicit none
real(selected_real_kind(Prec)) :: CrossArea,MassInWest,MassInEast,   &
   MassInTop,MassInBot,CurrentMassIn,MassIn
integer :: I,J,K

if ((I<1).or.(I>NumNodesX).or.(K<1).or.(K>NumNodesZ)) then
   MassIn = 0.D0
else
!----------
CrossArea  = YNodeWidths(J)*ZNodeWidths(K)
if (I > 1) then
   MassInWest = XInterfMassFlux(I-1,J,K)*CrossArea*Delta_t
else
   if (PresNodeTypes(I,J,K)=='F') then
      MassInWest = PresBoundVals(I,J,K)*CrossArea*Delta_t
   else
      MassInWest = 0.D0
   end if
end if
if (I < NumNodesX) then
   MassInEast = -XInterfMassFlux(I,J,K)*CrossArea*Delta_t
else
   if (PresNodeTypes(I,J,K)=='F') then
      MassInEast = PresBoundVals(I,J,K)*CrossArea*Delta_t
   else
      MassInEast = 0.D0
   end if
end if

CrossArea  = YNodeWidths(J)*XNodeWidths(I)
if (K > 1) then
   MassInTop = ZInterfMassFlux(I,J,K-1)*CrossArea*Delta_t
else
   if (PresNodeTypes(I,J,K)=='F') then
      MassInTop = PresBoundVals(I,J,K)*CrossArea*Delta_t
   else
      MassInTop = 0.D0
   end if
end if
if (K < NumNodesZ) then
   MassInBot = -ZInterfMassFlux(I,J,K)*CrossArea*Delta_t
else
   if (PresNodeTypes(I,J,K)=='F') then
      MassInBot = PresBoundVals(I,J,K)*CrossArea*Delta_t
   else
      MassInBot = 0.D0
   end if
end if

MassIn = MassInWest + MassInEast + MassInTop + MassInBot
!----------
end if
end
