subroutine MassTrackLocal(InitVars)

use CommonVars, only: Prec,Porosities,XNodeWidths,YNodeWidths,       &
   ZNodeWidths,Delta_t,NumNodesX,NumNodesZ,Pres,OldPres,NumNodesY,   &
   Time,TimeStepCheck,Delta_t,TimeStepFlag,NumTimeCuts,MaxTimeCuts,  &
   LogFile,PresNodeTypes,PresBoundVals,PhaseIndices,StepNum,         &
   MassErrNum,Sali,PrevMass,XInterfMassFlux,ZInterfMassFlux,         &
   HaliteDens,Temp,Pres,MassTol,LocalMassError,DeltaMassLocal,       &
   SaliNodeTypes,TempNodeTypes,BulkDens
implicit none
real(selected_real_kind(Prec)) :: TotalVolume,tInYears,MaxMassError, &
   CurrentMass,MassError,CalcBulkDens,Dens,MassErr,MassGain,MassIn
integer :: InitVars,I,J,K,TotalNodes,MaxMassErrLoc(3),MassPhaseInd,  &
   UpstreamBnd,CheckUpstream

MaxMassError = 0.D0
if (InitVars == 1) then
   MassErrNum = 0
   LocalMassError = 0.D0
   do I=1,NumNodesX
      do J=1,NumNodesY
         do K=1,NumNodesZ
            TotalVolume = XNodeWidths(I)*YNodeWidths(J)*ZNodeWidths(K)
            PrevMass(I,J,K) = CalcBulkDens(Temp(I,J,K),Pres(I,J,K), &
               Sali(I,J,K))*TotalVolume*Porosities(I,J,K)
            DeltaMassLocal(I,J,K) = 0.D0
         end do
      end do
   end do
else
!---------------------------------------------------------------------
do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         TotalVolume = XNodeWidths(I)*YNodeWidths(J)*ZNodeWidths(K)
         Dens = CalcBulkDens(Temp(I,J,K),Pres(I,J,K),Sali(I,J,K))
         CurrentMass = Dens*TotalVolume*Porosities(I,J,K)

         MassGain = CurrentMass-PrevMass(I,J,K)

         MassErr = 100.D0*MassError(I,J,K)

         UpstreamBnd = CheckUpstream(I,J,K)

         if ((MassErr > MaxMassError).and. &
            (Sali(I,J,K)>1.D-2)) then
            if (UpstreamBnd==0) then
               MaxMassError = MassErr
               MassPhaseInd = PhaseIndices(I,J,K)
               MaxMassErrLoc(1) = I
               MaxMassErrLoc(2) = J
               MaxMassErrLoc(3) = K
            end if
         end if

         PrevMass(I,J,K) = CurrentMass
      end do
   end do
end do
LocalMassError = MaxMassError
if ((TimeStepCheck == 'Y').and.(TimeStepFlag == 0)) then
   I = MaxMassErrLoc(1)
   J = 1
   K = MaxMassErrLoc(3)
   !if (MaxMassError>0.D0) then
   !   write(*,*) 'MaxMassError: ',MaxMassError
   !end if
   if (MaxMassError > MassTol) then
      MassErrNum = MassErrNum + 1
      if ((MassErrNum >= 1).and.(BulkDens(I,J,K)>300.D0)) then
         write(LogFile,*) 'Local mass percent error too large:', &
           MaxMassError,'%'
         TimeStepFlag = 1
         MassErrNum = 0
      end if
   else
      MassErrNum = 0
   end if
end if
!---------------------------------------------------------------------
end if
end
