subroutine ReadInFile1Arrays
! Purpose: To read user defined parameters from the file InFile1
!          into arrays.

use commonvars, only: PresNodeTypes,TempNodeTypes,SaliNodeTypes, &
                NumNodesX,NumNodesY,NumNodesZ,PresBoundVals,     &
                TempBoundVals,SaliBoundVals
implicit none
integer :: I,J,K

read(9,*)
read(9,*)
read(9,*)

! -------------------------------------------------------------------
!                       Pressure Node Types
! -------------------------------------------------------------------
do J=1,NumNodesY
   do K=1,NumNodesZ
      read(9,*) (PresNodeTypes(I,J,K),I=1,NumNodesX)
   end do
   if (J<NumNodesY) then
      read(9,*)
   end if
end do

50 format(2000E15.8) ! Pressure Boundary Values
60 format(2000E14.7) ! Temperature Boundary Values
70 format(2000E12.5) ! Salinity Boundary Values

write(8,*) 
write(8,*) '--- Pressure Node Types ---'
write(8,*) '([C]onstant Boundary, [F]lux Boundary,'
write(8,*) ' [U]pwind Boundary, [I]nterior)'
write(8,*)
do J=1,NumNodesY
   do K=1,NumNodesZ
      write(8,*) (PresNodeTypes(I,J,K),I=1,NumNodesX)
   end do
   write(8,*)
end do
! -------------------------------------------------------------------
!                       Temperature Node Types
! -------------------------------------------------------------------
read(9,*)
do J=1,NumNodesY
   do K=1,NumNodesZ
      read(9,*) (TempNodeTypes(I,J,K),I=1,NumNodesX)
   end do
   if (J<NumNodesY) then
      read(9,*)
   end if
end do

write(8,*) '--- Temperature Node Types ---'
write(8,*) '([C]onstant Boundary, [F]lux Boundary,'
write(8,*) ' [U]pwind Boundary, [I]nterior)'
write(8,*)
do J=1,NumNodesY
   do K=1,NumNodesZ
      write(8,*) (TempNodeTypes(I,J,K),I=1,NumNodesX)
   end do
   write(8,*)
end do
! -------------------------------------------------------------------
!                       Salinity Node Types
! -------------------------------------------------------------------
read(9,*)
do J=1,NumNodesY
   do K=1,NumNodesZ
      read(9,*) (SaliNodeTypes(I,J,K),I=1,NumNodesX)
   end do
   if (J<NumNodesY) then
      read(9,*)
   end if
end do

write(8,*) '--- Salinity Node Types ---'
write(8,*) '[C]onstant Boundary, [F]lux Boundary,'
write(8,*) '[U]pwind Boundary, [I]nterior)'
write(8,*)
do J=1,NumNodesY
   do K=1,NumNodesZ
      write(8,*) (SaliNodeTypes(I,J,K),I=1,NumNodesX)
   end do
   write(8,*)
end do
! -------------------------------------------------------------------
!                       Pressure Boundary Values
! -------------------------------------------------------------------
read(9,*)
do J=1,NumNodesY
   do K=1,NumNodesZ
      read(9,*) (PresBoundVals(I,J,K),I=1,NumNodesX)
   end do
   if (J<NumNodesY) then
      read(9,*)
   end if
end do

write(8,*) '--- Pressure Boundary Values (0=not a boundary) ---'
write(8,*)
do J=1,NumNodesY
   do K=1,NumNodesZ
      write(8,50) (real(PresBoundVals(I,J,K)),I=1,NumNodesX)
   end do
   write(8,*)
end do
! -------------------------------------------------------------------
!                       Temperature Boundary Values
! -------------------------------------------------------------------
read(9,*)
do J=1,NumNodesY
   do K=1,NumNodesZ
      read(9,*) (TempBoundVals(I,J,K),I=1,NumNodesX)
   end do
   if (J<NumNodesY) then
      read(9,*)
   end if
end do

write(8,*) '--- Temperature Boundary Values (0=not a boundary) ---'
write(8,*)
do J=1,NumNodesY
   do K=1,NumNodesZ
      write(8,60) (real(TempBoundVals(I,J,K)),I=1,NumNodesX)
   end do
   write(8,*)
end do
! -------------------------------------------------------------------
!                       Salinity Boundary Values
! -------------------------------------------------------------------
read(9,*)
do J=1,NumNodesY
   do K=1,NumNodesZ
      read(9,*) (SaliBoundVals(I,J,K),I=1,NumNodesX)
   end do
   if (J<NumNodesY) then
      read(9,*)
   end if
end do

write(8,*) '--- Salinity Boundary Values (0=not a boundary) ---'
write(8,*)
do J=1,NumNodesY
   do K=1,NumNodesZ
      write(8,70) (real(SaliBoundVals(I,J,K)),I=1,NumNodesX)
   end do
   write(8,*)
end do

end
