function SalinCorrect(I,J,K,Salin,SaltIn) Result(Answer)

use CommonVars, only: Prec,Porosities,OldPoros,OldSali,Temp,Pres,    &
   XNodeWidths,YNodeWidths,ZNodeWidths,MinSali,MaxSali,Temp,      &
   Pres,PrevSalt
implicit none
real(selected_real_kind(Prec)) :: CutOff,NewSalin,Correction,        &
   ConvergeTol,PrevSalin,CalcBulkDens,InitCorrect,CurrCorrect,       &
   SaltIn,Salin,Answer,CorrectRatio,TotalVolume,SaltError,DeltaX,    &
   Salin1,Salin2,SaltMass1,SaltMass2,DSaltMassDSalin,OldSaltMass,    &
   NewSaltMass,Tempr,Presr,OldSalin,SaltGain,PrevCorrect,Mass1,      &
   Mass2,NewMass,MassGain
integer I,J,K,ToCorrect,Flag,IterCount,MaxIter

NewSalin = Salin
CutOff = 1.D-9
Flag = 0
IterCount = 0
MaxIter = 100
ConvergeTol = 1.D-1
PrevSalin=Salin
TotalVolume = XNodeWidths(I)*YNodeWidths(J)*ZNodeWidths(K)
Tempr = Temp(I,J,K)
Presr = Pres(I,J,K)
OldSaltMass = PrevSalt(I,J,K)
do while (Flag==0)
   DeltaX = 0.5*1.D-5
   Salin1 = MAX(MinSali,NewSalin-DeltaX)
   Salin2 = MIN(MaxSali,NewSalin+DeltaX)

   Mass1 = Porosities(I,J,K)*TotalVolume* &
      CalcBulkDens(Tempr,Presr,Salin1)
   Mass2 = Porosities(I,J,K)*TotalVolume* &
      CalcBulkDens(Tempr,Presr,Salin2)
   SaltMass1 = Mass1*Salin1
   SaltMass2 = Mass2*Salin2
   DSaltMassDSalin = (SaltMass2-SaltMass1)/(Salin2-Salin1)

   NewMass = Porosities(I,J,K)*TotalVolume* &
      CalcBulkDens(Tempr,Presr,NewSalin)
   NewSaltMass = NewMass*NewSalin

   SaltGain = NewSaltMass - OldSaltMass

   Correction = (SaltIn - SaltGain)/ &
      DSaltMassDSalin

   NewSalin = PrevSalin + Correction

   Flag = 1
   if (IterCount==0) then
      Flag = 0
   elseif (IterCount==1) then
      InitCorrect = DABS(Correction)
      if (InitCorrect > CutOff) then
         Flag = 0
      end if
   else
      CurrCorrect = DABS(Correction)
      CorrectRatio = CurrCorrect/InitCorrect
      if (CorrectRatio > ConvergeTol) then
         Flag = 0
      end if
   end if
   PrevSalin = NewSalin
   PrevCorrect = Correction
   IterCount = IterCount + 1
   if (IterCount > MaxIter) then
      Flag = 1
   end if
end do
NewSalin = MAX(MinSali,NewSalin)
NewSalin = MIN(MaxSali,NewSalin)
Answer = NewSalin
end
