function SaltError(I,J,K,Salin)
! note: this function uses the CommonVars variable PrevSalt, which
! has its values set by MassTrackLocal

use CommonVars, only: Prec,XNodeWidths,YNodeWidths,ZNodeWidths,      &
   BulkDens,PrevSalt,Porosities,Delta_t,XInterfSaltFlux,             &
   ZInterfSaltFlux,SaliNodeTypes,SaliBoundVals,NumNodesX,NumNodesZ,  &
   Temp,Pres,DeltaSaltLocal
implicit none
real(selected_real_kind(Prec)) :: TotalVolume,CurrentMass,           &
   SaltIncrease,CrossArea,SaltInWest,SaltInEast,SaltInTop,SaltInBot, &
   CurrentSaltIn,SaltError,CurrentSalt,Salin,CalcBulkDens,SaltIn
integer :: I,J,K

TotalVolume = XNodeWidths(I)*YNodeWidths(J)*ZNodeWidths(K)
CurrentMass = CalcBulkDens(Temp(I,J,K),Pres(I,J,K),Salin)* &
   TotalVolume*Porosities(I,J,K)
CurrentSalt = CurrentMass*Salin

SaltIncrease = CurrentSalt - PrevSalt(I,J,K)

CurrentSaltIn = SaltIn(I,J,K)

if ((SaliNodeTypes(I,J,K)=='I').or. &
    (SaliNodeTypes(I,J,K)=='F')) then
   SaltError = DABS(CurrentSaltIn-SaltIncrease)
   if (CurrentSalt>0.D0) then
      SaltError = SaltError/CurrentSalt
   else
      SaltError = 0.D0
   end if
else
   SaltError = 0.D0
end if
DeltaSaltLocal(I,J,K) = CurrentSaltIn-SaltIncrease
end
