function SaltIn(I,J,K)

use CommonVars, only: Prec,XNodeWidths,YNodeWidths,ZNodeWidths,      &
   PrevSalt,Porosities,Delta_t,XInterfSaltFlux,ZInterfSaltFlux,      &
   SaliNodeTypes,SaliBoundVals,NumNodesX,NumNodesZ,Temp,Pres,Sali
implicit none
real(selected_real_kind(Prec)) :: CrossArea,SaltInWest,SaltInEast,   &
   SaltInTop,SaltInBot,CurrentSaltIn,SaltIn
integer :: I,J,K

if ((I<1).or.(I>NumNodesX).or.(K<1).or.(K>NumNodesZ)) then
   SaltIn = 0.D0
else
!----------
CrossArea  = YNodeWidths(J)*ZNodeWidths(K)
if (I > 1) then
   SaltInWest = XInterfSaltFlux(I-1,J,K)*CrossArea*Delta_t
else
   if (SaliNodeTypes(I,J,K)=='F') then
      SaltInWest = SaliBoundVals(I,J,K)*CrossArea*Delta_t
   else
      SaltInWest = 0.D0
   end if
end if
if (I < NumNodesX) then
   SaltInEast = -XInterfSaltFlux(I,J,K)*CrossArea*Delta_t
else
   if (SaliNodeTypes(I,J,K)=='F') then
      SaltInEast = SaliBoundVals(I,J,K)*CrossArea*Delta_t
   else
      SaltInEast = 0.D0
   end if
end if

CrossArea  = YNodeWidths(J)*XNodeWidths(I)
if (K > 1) then
   SaltInTop = ZInterfSaltFlux(I,J,K-1)*CrossArea*Delta_t
else
   if (SaliNodeTypes(I,J,K)=='F') then
      SaltInTop = SaliBoundVals(I,J,K)*CrossArea*Delta_t
   else
      SaltInTop = 0.D0
   end if
end if
if (K < NumNodesZ) then
   SaltInBot = -ZInterfSaltFlux(I,J,K)*CrossArea*Delta_t
else
   if (SaliNodeTypes(I,J,K)=='F') then
      SaltInBot = SaliBoundVals(I,J,K)*CrossArea*Delta_t
   else
      SaltInBot = 0.D0
   end if
end if

SaltIn = SaltInWest + SaltInEast + SaltInTop + SaltInBot
!----------
end if
end
