subroutine SaltTrackLocal(InitVars)

use CommonVars, only: Prec,Porosities,XNodeWidths,YNodeWidths,       &
   ZNodeWidths,Delta_t,NumNodesX,NumNodesZ,OldPres,NumNodesY,Time,   &
   TimeStepCheck,Delta_t,TimeStepFlag,NumTimeCuts,MaxTimeCuts,       &
   LogFile,PhaseIndices,StepNum,SaltErrNum,Sali,PrevSalt,            &
   SaliBoundVals,SaliNodeTypes,XInterfSaltFlux,ZInterfSaltFlux,      &
   HaliteDens,Temp,Pres,SaltTol,LocalSaltError,DeltaSaltLocal
implicit none
real(selected_real_kind(Prec)) :: TotalVolume,tInYears,MaxSaltError, &
   CurrentSalt,SaltError,CalcBulkDens,Dens,SaltErr
integer :: InitVars,I,J,K,TotalNodes,MaxSaltErrLoc(3),SaltPhaseInd,  &
   UpstreamBnd,CheckUpstream

MaxSaltError = 0.D0
if (InitVars == 1) then
   SaltErrNum = 0
   LocalSaltError = 0.D0
   do I=1,NumNodesX
      do J=1,NumNodesY
         do K=1,NumNodesZ
            TotalVolume = XNodeWidths(I)*YNodeWidths(J)*ZNodeWidths(K)
            PrevSalt(I,J,K) = CalcBulkDens(Temp(I,J,K),Pres(I,J,K), &
               Sali(I,J,K))*TotalVolume*Porosities(I,J,K)*Sali(I,J,K)
            DeltaSaltLocal(I,J,K) = 0.D0
         end do
      end do
   end do
else
!---------------------------------------------------------------------
do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         TotalVolume = XNodeWidths(I)*YNodeWidths(J)*ZNodeWidths(K)
         Dens = CalcBulkDens(Temp(I,J,K),Pres(I,J,K),Sali(I,J,K))
         CurrentSalt = Dens*TotalVolume*Porosities(I,J,K)*Sali(I,J,K)

         SaltErr = 100.D0*SaltError(I,J,K,Sali(I,J,K))

         UpstreamBnd = CheckUpstream(I,J,K)

         if ((SaltErr > MaxSaltError).and. &
            (Sali(I,J,K)>1.D-2)) then
            if (UpstreamBnd==0) then
               MaxSaltError = SaltErr
               SaltPhaseInd = PhaseIndices(I,J,K)
               MaxSaltErrLoc(1) = I
               MaxSaltErrLoc(2) = J
               MaxSaltErrLoc(3) = K
            end if
         end if

         PrevSalt(I,J,K) = CurrentSalt
      end do
   end do
end do
LocalSaltError = MaxSaltError
if ((TimeStepCheck == 'Y').and.(TimeStepFlag == 0)) then
   I = MaxSaltErrLoc(1)
   J = 1
   K = MaxSaltErrLoc(3)
   !if (MaxSaltError>0.D0) then
   !   write(*,*) 'MaxSaltError: ',MaxSaltError
   !end if
   if (MaxSaltError > SaltTol) then
      SaltErrNum = SaltErrNum + 1
      if (SaltErrNum >= 1) then
         write(LogFile,*) 'Local salt percent error too large:', &
           MaxSaltError,'%'
         TimeStepFlag = 1
         SaltErrNum = 0
      end if
   else
      SaltErrNum = 0
   end if
end if
!---------------------------------------------------------------------
end if
end
