subroutine SetBoundaries
! Purpose: To make sure the appropriate boundary values are
!          set in the temperature, pressure, and salinity
!          matrices.

use CommonVars, only: Prec,Pres,Temp,Sali,PresNodeTypes, &
    TempNodeTypes,SaliNodeTypes,PresBoundVals,           &
    TempBoundVals,SaliBoundVals,NumNodesX,NumNodesY,     &
    NumNodesZ
implicit none
integer :: I,J,K

do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         if (TempNodeTypes(I,J,K)=='C') then
            Temp(I,J,K)=TempBoundVals(I,J,K)
         end if
         if (PresNodeTypes(I,J,K)=='C') then
            Pres(I,J,K)=PresBoundVals(I,J,K)
         end if
         if (SaliNodeTypes(I,J,K)=='C') then
            Sali(I,J,K)=SaliBoundVals(I,J,K)
         end if
      end do
   end do
end do

end
