program PickUp
! Purpose: to take the temperatures, pressures, and salinities from
! the last entries in OutFile1 and put them into InFile0 to make it
! easier to pick up runs where they left off

implicit none
integer :: I,Flag,NumNodesY,NumNodesZ,NumNodesX,EOF,J,K
real :: Pres(200,200),Temp(200,200),Sali(200,200)
character :: Check(3)

open(unit=10,file='InFile0',status='old')

! read the dimension info from the top of InFile0
read(10,*)
read(10,*) NumNodesX,NumNodesY,NumNodesZ

! Now get the temp, pres, and sali values from OutFile1
open(unit=11,file='OutFile1',status='old')
EOF=0
do while (EOF==0)
   read(11,*,iostat=EOF)
end do

Flag = 0
do while (Flag==0)
   backspace(11)
   backspace(11)
   read(11,2) Check(1),Check(2)
   2 format(T6,3A)
   if ((Check(1)=='P').and.(Check(2)=='r')) then
      Flag = 1
   end if
end do
read(11,*)
read(11,*)

do K=1,NumNodesZ
   read(11,*) (Pres(K,I),I=1,NumNodesX)
end do
read(11,*)
read(11,*)
read(11,*)
read(11,*)
do K=1,NumNodesZ
   read(11,*) (Temp(K,I),I=1,NumNodesX)
end do
read(11,*)
read(11,*)
read(11,*)
read(11,*)
do K=1,NumNodesZ
   read(11,*) (Sali(K,I),I=1,NumNodesX)
end do
close(11)

! Now just put the array values into InFile0
Flag=0
3 format(T1,3A)
do while (Flag==0)
   read(10,3) Check(1),Check(2),Check(3)
   if ((Check(1)=='P').and.(Check(2)=='r').and. &
       (Check(3)=='e')) then
      Flag=1
   end if
end do

20 format(2000E15.8) ! Pressures
30 format(2000E14.7) ! Temperatures
40 format(2000E12.5) ! Salinities

write(10,*) 'F'
do K=1,NumNodesZ
   write(10,20) (Pres(K,I),I=1,NumNodesX)
end do
write(10,*) 'Temperature (C)'
write(10,*) 'F'
do K=1,NumNodesZ
   write(10,30) (Temp(K,I),I=1,NumNodesX)
end do
write(10,*) 'Salinity (wt% NaCl)'
write(10,*) 'F'
do K=1,NumNodesZ
   write(10,40) (Sali(K,I),I=1,NumNodesX)
end do

close(10)
end
