subroutine FillMatrix(XNodeWidths,ZNodeWidths,Matrix,MainMenuChoice)

use CommonVars, only: MaxX,MaxY,MaxZ,Prec,NumNodesX,NumNodesZ,       &
   ComputeStaticPres
implicit none
real(selected_real_kind(Prec)) :: Matrix(MaxX,MaxY,MaxZ),            &
   XNodeWidths(MaxX),ZNodeWidths(MaxZ),ConstValue,StartValueZ(MaxX), &
   EndValueX(MaxZ),Slope,TotalDist,Dist,EndValueZ(MaxX),             &
   StartValueX(MaxZ),SurfPres
integer :: Flag,Choice,StartRow,EndRow,StartCol,EndCol,Row,Col,I,K,  &
   MainMenuChoice
character :: CLorT,CorF

write(*,*) 'Select from the following menu: '
Flag = 0
do while (Flag==0)
   write(*,*) '1 select starting and ending rows/columns'
   write(*,*) '2 return to main menu'
   if (MainMenuChoice==4) then
      write(*,*) '3 hydrostatic profile'
   end if
   write(*,*)
   write(*,*) 'Choice: '
   read(*,*) Choice
   if (Choice==2) then
      Flag = 1
   elseif (Choice==1) then
      write(*,*) 'starting row: '
      read(*,*) StartRow
      write(*,*) 'ending row: '
      read(*,*) EndRow
      write(*,*) 'starting column: '
      read(*,*) StartCol
      write(*,*) 'ending column: '
      read(*,*) EndCol
      write(*,*) 'constant (C), linear left to right (L), or'
      write(*,*) 'linear top to bottom (T)?'
      read(*,*) CLorT
      if (CLorT=='C') then
         write(*,*) 'constant value: '
         read(*,*) ConstValue
         do Row=StartRow,EndRow
            do Col=StartCol,EndCol
               Matrix(Col,1,Row) = ConstValue
            end do
         end do
      elseif (CLorT=='L') then
         if (((StartRow==1).and.(EndRow==NumNodesZ)).and. &
             ((StartCol==1).and.(EndCol==NumNodesX))) then
            write(*,*) 'use constant starting and ending values,'
            write(*,*) 'or use values from the first and last' 
            write(*,*) 'columns (C or F)?'
            read(*,*) CorF
         else
            CorF = 'C'
         end if

         if (CorF=='C') then
            write(*,*) 'starting value: '
            read(*,*) StartValueX(1)
            write(*,*) 'ending value: '
            read(*,*) EndValueX(1)
            do K=2,NumNodesZ
               EndValueX(K)=EndValueX(1)
               StartValueX(K)=StartValueX(1)
            end do
         else
            do K=1,NumNodesZ
               EndValueX(K)=Matrix(NumNodesX,1,K)
               StartValueX(K)=Matrix(1,1,K)
            end do
         end if
         do Col=StartCol,EndCol
            if (Col==StartCol) then
               TotalDist=0.D0
            else
               TotalDist=TotalDist + XNodeWidths(Col-1)/2.D0 + & 
                                     XNodeWidths(Col)/2.D0
            end if
         end do
         do Row=StartRow,EndRow
            Slope = (EndValueX(Row)-StartValueX(Row))/TotalDist
            do Col=StartCol,EndCol
               if (Col==StartCol) then
                  Dist = 0.D0
               else
                  Dist = Dist + XNodeWidths(Col-1)/2.D0 + &
                                XNodeWidths(Col)/2.D0
               end if
               Matrix(Col,1,Row)=Slope*Dist+StartValueX(Row)
            end do
         end do
      elseif (CLorT=='T') then
         if (((StartRow==1).and.(EndRow==NumNodesZ)).and. &
             ((StartCol==1).and.(EndCol==NumNodesX))) then
            write(*,*) 'use constant starting and ending values,'
            write(*,*) 'or use values from the first and last'
            write(*,*) 'rows (C or F)?'
            read(*,*) CorF
         else
            CorF = 'C'
         end if

         if (CorF=='C') then
            write(*,*) 'starting value: '
            read(*,*) StartValueZ(1)
            write(*,*) 'ending value: '
            read(*,*) EndValueZ(1)
            do I=2,NumNodesX
               EndValueZ(I)=EndValueZ(1)
               StartValueZ(I)=StartValueZ(1)
            end do
         else
            do I=1,NumNodesX
               EndValueZ(I)=Matrix(I,1,NumNodesZ)
               StartValueZ(I)=Matrix(I,1,1)
            end do
         end if
         do Row=StartRow,EndRow
            if (Row==StartRow) then
               TotalDist = 0.D0
            else
               TotalDist = TotalDist + ZNodeWidths(Row-1)/2.D0 + &
                                       ZNodeWidths(Row)/2.D0
            end if
         end do
         do Col=StartCol,EndCol
            Slope = (EndValueZ(Col)-StartValueZ(Col))/TotalDist
            do Row=StartRow,EndRow
               if (Row==StartRow) then
                  Dist = 0.D0
               else
                  Dist = Dist + ZNodeWidths(Row-1)/2.D0 + &
                                ZNodeWidths(Row)/2.D0
               end if
               Matrix(Col,1,Row)=Slope*Dist+StartValueZ(Col)
            end do
         end do
      end if
   elseif ((MainMenuChoice==4).and.(Choice == 3)) then
      ComputeStaticPres = 1
      write(*,*) 'Value of constant seafloor pressure: '
      read(*,*) SurfPres
      do I=1,NumNodesX
         Matrix(I,1,1) = SurfPres
      end do
   end if
end do

end
