subroutine Initialize
! Purpose: once the number of nodes in each direction is known, 
! fills in all other entries for the input files, so that 
! they can be saved without the user having to initialize all
! the entries

use CommonVars, only: XNodeWidths,YNodeWidths,ZNodeWidths,  &
   NumNodesX,NumNodesY,NumNodesZ,RockPerms,PresNodeTypes,   &
   TempNodeTypes,SaliNodeTypes,PresBoundVals,TempBoundVals, &
   SaliBoundVals,Pres,Temp,Sali,MaxX,MaxY,MaxZ
implicit none
integer :: I,J,K

do I=1,MaxX
   XNodeWidths(I) = 0.D0
end do
do J=1,MaxY
   YNodeWidths(J) = 0.D0
end do
do K=1,MaxZ
   ZNodeWidths(K) = 0.D0
end do
do I=1,NumNodesX
   XNodeWidths(I) = 1.D0
end do
do J=1,NumNodesY
   YNodeWidths(J) = 1.D0
end do
do K=1,NumNodesZ
   ZNodeWidths(K) = 1.D0
end do

do I=1,MaxX
   do J=1,MaxY
      do K=1,MaxZ
         RockPerms(I,J,K)=0.D0
         Pres(I,J,K) = 0.D0
         Temp(I,J,K) = 0.D0
         Sali(I,J,K) = 0.D0
         PresNodeTypes(I,J,K) = ''
         TempNodeTypes(I,J,K) = ''
         SaliNodeTypes(I,J,K) = ''
         PresBoundVals(I,J,K) = 0.D0
         TempBoundVals(I,J,K) = 0.D0
         SaliBoundVals(I,J,K) = 0.D0
      end do
   end do
end do
do I=1,NumNodesX
   do J=1,NumNodesY
      do K=1,NumNodesZ
         RockPerms(I,J,K)=1.D-12
         Pres(I,J,K)=250.D5
         Temp(I,J,K)=10.D0
         Sali(I,J,K)=3.2D0
         PresNodeTypes(I,J,K)='I'
         TempNodeTypes(I,J,K)='I'
         SaliNodeTypes(I,J,K)='I'
         PresBoundVals(I,J,K)=0.D0
         TempBoundVals(I,J,K)=0.D0
         SaliBoundVals(I,J,K)=0.D0
      end do
   end do
end do

end
