subroutine ReadInFile0Arrays
! Purpose: To read user defined parameters from the file InFile0 
!          into arrays.

use commonvars, only: XNodeWidths,YNodeWidths,ZNodeWidths,NumNodesX, &
                NumNodesY,NumNodesZ,Prec,Porosities,RockPerms,Temp,  &
                Pres,Sali,OldPoros,ComputeStaticPres
implicit none
real (selected_real_kind(Prec)) :: ConstWidth, ConstPorosity,        &
     ConstRockPerm, ConstPres, ConstTemp, ConstSali
integer :: I,J,K
character FreeOrConst

! X node widths
read(7,*)
read(7,*) FreeOrConst
!--------------------------------------------------------------------
!                       X Node Widths (m)
!--------------------------------------------------------------------
if (FreeOrConst=='C') then
   read(7,*) ConstWidth
   do I=1,NumNodesX
      XNodeWidths(I) = ConstWidth
   end do
elseif (FreeOrConst=='F') then
   do I=1,NumNodesX
      read(7,*) XNodeWidths(I)
   end do
else
   write(*,*) 'Invalid Value of FreeOrConst: ',FreeOrConst
   STOP
endif

write(8,*)
write(8,*) '--- X Node Widths (m) ---'
do I=1,NumNodesX
   write(8,*) real(XNodeWidths(I))
end do
write(8,*)
!--------------------------------------------------------------------
!                       Y Node Widths (m)
!--------------------------------------------------------------------
read(7,*)
read(7,*) FreeOrConst
if (FreeOrConst=='C') then
   read(7,*) ConstWidth
   do J=1,NumNodesY
      YNodeWidths(J) = ConstWidth
   end do
elseif (FreeOrConst=='F') then
   do J=1,NumNodesY
      read(7,*) YNodeWidths(J)
   end do
else
   write(*,*) 'Invalid Value of FreeOrConst: ',FreeOrConst
   STOP
end if

write(8,*) '--- Y Node Widths (m) ---'
do J=1,NumNodesY
   write(8,*) real(YNodeWidths(J))
end do
write(8,*)
!--------------------------------------------------------------------
!                       Z Node Widths (m)
!--------------------------------------------------------------------
read(7,*)
read(7,*) FreeOrConst
if (FreeOrConst=='C') then
   read(7,*) ConstWidth
   do K=1,NumNodesZ
      ZNodeWidths(K) = ConstWidth
   end do
elseif (FreeOrConst=='F') then
   do K=1,NumNodesZ
      read(7,*) ZNodeWidths(K)
   end do
else
   write(*,*) 'Invalid Value of FreeOrConst: ',FreeOrConst
   STOP
end if

write(8,*) '--- Z Node Widths (m) ---'
do K=1,NumNodesZ
   write(8,*) real(ZNodeWidths(K))
end do
write(8,*)
!--------------------------------------------------------------------
!                       Porosities (unitless)
!--------------------------------------------------------------------
read(7,*)
read(7,*) FreeOrConst
if (FreeOrConst=='C') then
   read(7,*) ConstPorosity
   do I=1,NumNodesX
      do J=1,NumNodesY
         do K=1,NumNodesZ
            Porosities(I,J,K) = ConstPorosity
            OldPoros(I,J,K) = Porosities(I,J,K)
         end do
      end do
   end do
elseif (FreeOrConst=='F') then
   do J=1,NumNodesY
      do K=1,NumNodesZ
         read(7,*) (Porosities(I,J,K),I=1,NumNodesX)
         OldPoros(I,J,K) = Porosities(I,J,K)
      end do
      if (J<NumNodesY) then
         read(7,*)
      end if
   end do
else
   write(*,*) 'Invalid Value of FreeOrConst: ',FreeOrConst
   STOP
end if

10 format(2000E10.3) ! Porosities, Permeabilities
20 format(2000E15.8) ! Pressures
30 format(2000E14.7) ! Temperatures
40 format(2000E12.5) ! Salinities

write(8,*)
write(8,*) '--- Porosities (unitless) ---'
do J=1,NumNodesY
   write(8,*) 'Slice: ',J
   do K=1,NumNodesZ
      write(8,10) (real(Porosities(I,J,K)),I=1,NumNodesX)
   end do
end do
!--------------------------------------------------------------------
!                       Permeabilities (m^2)
!--------------------------------------------------------------------
read(7,*)
read(7,*) FreeOrConst
if (FreeOrConst=='C') then
   read(7,*) ConstRockPerm
   do I=1,NumNodesX
      do J=1,NumNodesY
         do K=1,NumNodesZ
            RockPerms(I,J,K) = ConstRockPerm
         end do
      end do
   end do
elseif (FreeOrConst=='F') then
   do J=1,NumNodesY
      do K=1,NumNodesZ
         read(7,*) (RockPerms(I,J,K),I=1,NumNodesX)
      end do
      if (J<NumNodesY) then
         read(7,*)
      end if
   end do
else
   write(*,*) 'Invalid Value of FreeOrConst: ',FreeOrConst
   STOP
end if

write(8,*)
write(8,*) '--- Rock Permeabilities (m^2) ---'
do J=1,NumNodesY
   write(8,*) 'Slice: ',J
   do K=1,NumNodesZ
      write(8,10) (dble(RockPerms(I,J,K)),I=1,NumNodesX)
   end do
end do
!--------------------------------------------------------------------
!                       Pressures (Pa)
!--------------------------------------------------------------------
read(7,*)
read(7,*) FreeOrConst
if (FreeOrConst=='C') then
   read(7,*) ConstPres
   do I=1,NumNodesX
      do J=1,NumNodesY
         do K=1,NumNodesZ
            Pres(I,J,K) = ConstPres
         end do
      end do
   end do
elseif (FreeOrConst=='F') then
   do J=1,NumNodesY
      do K=1,NumNodesZ
         read(7,*) (Pres(I,J,K),I=1,NumNodesX)
      end do
      if (J<NumNodesY) then
         read(7,*)
      end if
   end do
elseif (FreeOrConst=='S') then
   do J=1,NumNodesY
      read(7,*) (Pres(I,1,1),I=1,NumNodesX)
      if (J<NumNodesY) then
         read(7,*)
      end if
   end do
   ComputeStaticPres = 1
else
   write(*,*) 'Invalid Value of FreeOrConst: ',FreeOrConst
   STOP
end if

write(8,*)
write(8,*) '--- Pressures (Pa) ---'
do J=1,NumNodesY
   write(8,*) 'Slice: ',J
   do K=1,NumNodesZ
      write(8,20) (real(Pres(I,J,K)),I=1,NumNodesX)
   end do
end do
!--------------------------------------------------------------------
!                       Temperatures (C)
!--------------------------------------------------------------------
read(7,*)
read(7,*) FreeOrConst
if (FreeOrConst=='C') then
   read(7,*) ConstTemp
   do I=1,NumNodesX
      do J=1,NumNodesY
         do K=1,NumNodesZ
            Temp(I,J,K) = ConstTemp
         end do
      end do
   end do
elseif (FreeOrConst=='F') then
   do J=1,NumNodesY
      do K=1,NumNodesZ
         read(7,*) (Temp(I,J,K),I=1,NumNodesX)
      end do
      if (J<NumNodesY) then
         read(7,*)
      end if
   end do
else
   write(*,*) 'Invalid Value of FreeOrConst: ',FreeOrConst
   STOP
end if

write(8,*)
write(8,*) '--- Temperatures (C) ---'
do J=1,NumNodesY
   write(8,*) 'Slice: ',J
   do K=1,NumNodesZ
      write(8,30) (real(Temp(I,J,K)),I=1,NumNodesX)
   end do
end do
!--------------------------------------------------------------------
!                       Salinities (wt% NaCl)
!--------------------------------------------------------------------
read(7,*)
read(7,*) FreeOrConst
if (FreeOrConst=='C') then
   read(7,*) ConstSali
   do I=1,NumNodesX
      do J=1,NumNodesY
         do K=1,NumNodesZ
            Sali(I,J,K) = ConstSali
         end do
      end do
   end do
elseif (FreeOrConst=='F') then
   do J=1,NumNodesY
      do K=1,NumNodesZ
         read(7,*) (Sali(I,J,K),I=1,NumNodesX)
      end do
      if (J<NumNodesY) then
         read(7,*)
      end if
   end do
else
   write(*,*) 'Invalid Value of FreeOrConst: ',FreeOrConst
   STOP
end if

write(8,*)
write(8,*) '--- Salinities (wt% NaCl) ---'
do J=1,NumNodesY
   write(8,*) 'Slice: ',J
   do K=1,NumNodesZ
       write(8,40) (real(Sali(I,J,K)),I=1,NumNodesX)
   end do
end do
end
