subroutine WriteInFile0

use CommonVars
implicit none
integer Row,Col,Flag
real(selected_real_kind(Prec)) :: Value

open(unit=10,file='InFile0.new')

write(10,10) & 
   'NumNodesX NumNodesY NumNodesZ Suppress Screen Messages? ([Y]es,[N]o)'
10 format(T1,A)
write(10,11) NumNodesX,NumNodesY,NumNodesZ,SuppressScreen
11 format(T1,1I3,T11,1I3,T21,1I3,T31,A)
write(10,10) &
   'TimeStepIncr Dispersivity(unitless) CorrelationLength(m)'
write(10,12) TimeStepIncr,Dispersivity,CorrelationLength
12 format(T1,D10.5,T15,D10.5,T38,D10.5)
write(10,10) &
   'BoundValGradual? ([Y]es,[N]o) BoundSide ([T]op,[B]ottom,[W]est,[E]ast)'
write(10,5) BoundValGradual,BoundSide
write(10,10) &
   'EquationType (P,T,X) StartBoundNode    EndBoundNode    IncreaseAmount'
write(10,6) EquationType,StartBoundNode,EndBoundNode,IncreaseAmount
write(10,10) 'IncreaseTime (s)      MaxPIter       MaxTIter'
write(10,7) IncreaseTime,MaxPIter,MaxTIter
5 format(T1,A,T31,A)
6 format(T1,A,T22,1I3,T40,1I3,T56,D10.5)
7 format(T1,D10.5,T22,1I6,T37,1I6)
8 format(T1,1I3)
13 format(T1,A,T32,D10.5,T47,D10.5,T60,D10.5)
14 format(T1,D9.4,T11,D9.4,T21,D9.4,T31,1I2,T48,A)
80 format (T1,1I3,T24,A)
81 format (T1,A,T24,A)
write(10,81) &
   'Number of time periods TimeStepCheck (Y or N)'
write(10,80) NumOf_t_Periods,TimeStepCheck
write(10,10) &
   'TotalTime   PrintFreq    Delta_t        MaxDelta_t     MinDelta_t'
do Row=1,NumOf_t_Periods
   write(10,19) tPeriodLengths(Row),PrintFreqArray(Row),Delta_t_Array(Row), &
                MaxDelta_t_Array(Row),MinDelta_t_Array(Row)
   19 format(T1,D10.5,T13,D10.5,T26,D10.5,T42,D10.5,T58,D10.5)
end do
write(10,10) &
   'RockDens(kg/m^3) CpRock(J/kg/C) RockThermCond(W/m/C) Grav(m/s^2) Tilt'
write(10,16) RockDens,CpRock,RockThermCond,Grav,Tilt
16 format(T1,D10.5,T18,D10.5,T33,D10.5,T55,D9.4,T66,D9.4)
write(10,10) &
 'HaliteDens(kg/m^3) CpHalite(J/kg/C) FluidThermCond(W/m/C) SaltChemDiff(m^2/s)'
write(10,17) HaliteDens,CpHalite,FluidThermCond,SaltChemDiff
17 format(T1,D10.5,T20,D10.5,T37,D10.5,T59,D10.5)
write(10,10) &
   'All of the following parameters have type = [C]onstant or [F]ree'
write(10,10) &
   'Node widths in the x direction(m)'

Value = XNodeWidths(1)
Flag = 0
do Col=1,NumNodesX
   if (Value==XNodeWidths(Col)) then
   else
      Flag = 1
   end if
end do

if (Flag==0) then
   write(10,18) 'C'
   18 format(T1,A)
   write(10,*) Value
else
   write(10,18) 'F'
   do Col=1,NumNodesX
      write(10,*) XNodeWidths(Col)
   end do
end if

write(10,10) &
   'Node widths in the y direction(m)'
write(10,18) 'C'
write(10,*) 1.D0

write(10,10) &
   'Node widths in the z direction(m)'

Value = ZNodeWidths(1)
Flag = 0
do Row=1,NumNodesZ
   if (Value==ZNodeWidths(Row)) then
   else
      Flag = 1
   end if
end do

if (Flag==0) then
   write(10,18) 'C'
   write(10,*) Value
else
   write(10,18) 'F'
   do Row=1,NumNodesZ
      write(10,*) ZNodeWidths(Row)
   end do
end if

write(10,10) 'Porosity(unitless)'
write(10,18) 'C'
write(10,*) Porosities(1,1,1)

write(10,10) 'Permeability(m^2)'

Value = RockPerms(1,1,1)
Flag = 0
do Row=1,NumNodesZ
   do Col=1,NumNodesX
      if (Value==RockPerms(Col,1,Row)) then
      else
         Flag = 1
      end if
   end do
end do

20 format(2000E15.8) ! Pressures
30 format(2000E14.7) ! Temperatures
40 format(2000E12.5) ! Salinities
60 format(2000E10.3) ! Permeabilities

if (Flag==0) then
   write(10,18) 'C'
   write(10,*) Value
else
   write(10,18) 'F'
   do Row=1,NumNodesZ
      write(10,60) (RockPerms(Col,1,Row),Col=1,NumNodesX)
   end do
end if

write(10,10) 'Pressure(Pa [=1.D-5 bar])'
Value = Pres(1,1,1)
Flag = 0
do Row=1,NumNodesZ
   do Col=1,NumNodesX
      if (Value==Pres(Col,1,Row)) then
      else
         Flag = 1
      end if
   end do
end do

if (ComputeStaticPres==1) then
   write(10,*) 'S'
   write(10,20) (Pres(Col,1,1),Col=1,NumNodesX)
elseif (Flag==0) then
   write(10,18) 'C'
   write(10,*) Value
else
   write(10,18) 'F'
   do Row=1,NumNodesZ
      write(10,20) (Pres(Col,1,Row),Col=1,NumNodesX)
   end do
end if

write(10,10) 'Temperature(C)'
Value = Temp(1,1,1)
Flag = 0
do Row=1,NumNodesZ
   do Col=1,NumNodesX
      if (Value==Temp(Col,1,Row)) then
      else
         Flag = 1
      end if
   end do
end do

if (Flag==0) then
   write(10,18) 'C'
   write(10,*) Value
else
   write(10,18) 'F'
   do Row=1,NumNodesZ
      write(10,30) (Temp(Col,1,Row),Col=1,NumNodesX)
   end do
end if

write(10,10) 'Salinity(wt% NaCl)'
Value = Sali(1,1,1)
Flag = 0
do Row=1,NumNodesZ
   do Col=1,NumNodesX
      if (Value==Sali(Col,1,Row)) then
      else
         Flag = 1
      end if
   end do
end do

if (Flag==0) then
   write(10,18) 'C'
   write(10,*) Value
else
   write(10,18) 'F'
   do Row=1,NumNodesZ
      write(10,40) (Sali(Col,1,Row),Col=1,NumNodesX)
   end do
end if

close(10)
end
