def flowplot(Option) :
  import numpy
  from numpy import zeros,array,append,loadtxt
  from pylab import load,setp
  from math import sqrt,atan2,acos
  import matplotlib
  import matplotlib.pyplot as plt
  import math

  Tempr        = loadtxt("Tempr.dat")
  Presr        = loadtxt("Presr.dat")
  BulkSaln     = loadtxt("BulkSaln.dat")
  LiqVolSat    = loadtxt("LiqVolSat.dat")
  BulkDens     = loadtxt("BulkDens.dat")
  BulkEnth     = loadtxt("BulkEnth.dat")
  XWidths      = loadtxt("XWidths.dat")
  ZWidths      = loadtxt("ZWidths.dat")
  LiquidSali   = loadtxt("LiquidSali.dat")
  LiquidEnth   = loadtxt("LiquidEnth.dat")

  XWidths = array(XWidths,ndmin=1)
  if (len(XWidths)==1) :
    LiquidVeloc  = loadtxt("LiquidVeloc.dat")
    VaporVeloc   = loadtxt("VaporVeloc.dat")

  VaporSali    = loadtxt("VaporSali.dat")
  VaporEnth    = loadtxt("VaporEnth.dat")
  LiquidDens   = loadtxt("LiquidDens.dat")
  VaporDens    = loadtxt("VaporDens.dat")
  SurfHeatFlux = loadtxt("SurfHeatFlux.dat")

  TotalMass = 0.0
  TotalSalt = 0.0
  if (len(XWidths) > 1) :
    VaporDensRows = VaporDens.shape[0]
    VaporDensCols = VaporDens.shape[1]
    for i in range(0,VaporDensRows) :
      for j in range(0,VaporDensCols) :
        if (VaporEnth[i][j]==0.0) :
           VaporDens[i][j]=0
           VaporSali[i][j]=0
        if (LiquidEnth[i][j]==0.0) :
           LiquidDens[i][j]=0
           LiquidSali[i][j]=0
        TotalMass = TotalMass + BulkDens[i][j]*XWidths[j]* \
           ZWidths[i]*0.1
        TotalSalt = TotalSalt + BulkDens[i][j]*XWidths[j]* \
           ZWidths[i]*BulkSaln[i][j]*0.1
        if (BulkSaln[i][j]>10) :
           BulkSaln[i][j] = 10
  else :
    BulkDensRows = BulkDens.shape[0]
    for i in range(0,BulkDensRows) :
      TotalMass = TotalMass + BulkDens[i]*XWidths[0]* \
         ZWidths[i]*0.1
      TotalSalt = TotalSalt + BulkDens[i]*XWidths[0]* \
         ZWidths[i]*BulkSaln[i]*0.1

  SysSalin = TotalSalt/TotalMass
  print 'system bulk salin: ',SysSalin
 
  TempMat = Tempr
  PresMat = Presr
  PresMat = PresMat/10**5
  SaliMat = BulkSaln
  EnthMat = BulkEnth/1000
  DensMat = BulkDens
  LiqVols = LiqVolSat
  VaporSali = VaporSali
  LiquidSali = LiquidSali
  DeltaX  = XWidths
  DeltaZ  = ZWidths
  LiquidEnth = LiquidEnth/1000
  VaporEnth = VaporEnth/1000
  #if (len(XWidths)==1) :
  #  LiquidVeloc = LiquidVeloc*100*86400*365.25
  #  VaporVeloc = VaporVeloc*100*86400*365.25

  Cumul=XWidths[0]/2.0
  XCoords = array(len(XWidths)*[0.],numpy.float)
  XCoords[0]=Cumul
  if (len(XWidths)>1) :
    for i in range(1,len(XWidths)) :
       CurrentDist = XWidths[i]/2.0+XWidths[i-1]/2.0
       Cumul = Cumul + CurrentDist
       XCoords[i] = Cumul

  Cumul=ZWidths[0]/2.0
  ZCoords = array(len(ZWidths)*[0.],numpy.float)
  ZCoords[0] = Cumul

  for i in range(1,len(ZWidths)) :
    CurrentDist = ZWidths[i]/2.0+ZWidths[i-1]/2.0
    Cumul = Cumul + CurrentDist
    ZCoords[i] = Cumul

  if (len(XCoords)==1) :
    LiquidVeloc = append(LiquidVeloc,0)
    VaporVeloc  = append(VaporVeloc,0)

  XCoords = XCoords/1000.0
  ZCoords = ZCoords/1000.0

  Resolve = 100
  if (len(XWidths)>1) :
    if (Option == 0) :
      plt.subplot(231)
      plt.contourf(XCoords,ZCoords,TempMat,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Temperature (C)")
      plt.ylabel("mbsf")
      plt.colorbar(format = "%.1f")

      plt.subplot(232)
      plt.contourf(XCoords,ZCoords,PresMat,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Pressure (bars)")
      plt.colorbar(format = "%.1f")

      plt.subplot(233)
      plt.contourf(XCoords,ZCoords,SaliMat,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Salinity (wt% NaCl)")
      plt.colorbar(format = "%.3f")

      plt.subplot(234)
      plt.contourf(XCoords,ZCoords,LiqVols,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Liquid Volume Saturation")
      plt.ylabel("mbsf")
      plt.xlabel("distance (km)")
      plt.colorbar(format = "%.3f")

      plt.subplot(235)
      plt.contourf(XCoords,ZCoords,DensMat,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Bulk Density (kg/m^3)")
      plt.xlabel("distance (km)")
      plt.colorbar(format = "%.0f")

      plt.subplot(236)
      plt.contourf(XCoords,ZCoords,EnthMat,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Bulk Enthalpy (kJ/kg)")
      plt.xlabel("distance (km)")
      plt.colorbar(format = "%.0f")
      plt.show()

    if (Option == 1) :
      plt.figure()
      plt.subplot(231)
      plt.contourf(XCoords,ZCoords,LiquidSali,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Liquid Salinity (wt% NaCl)")
      plt.ylabel("mbsf")
      plt.colorbar(format = "%.3f")

      plt.subplot(232)
      plt.contourf(XCoords,ZCoords,VaporSali,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Vapor Salinity (wt% NaCl)")
      plt.colorbar(format = "%.3f")

      plt.subplot(233)
      plt.contourf(XCoords,ZCoords,LiquidEnth,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Liquid Enthalpy (kJ/kg)")
      plt.colorbar(format = "%.0f")

      plt.subplot(234)
      plt.contourf(XCoords,ZCoords,VaporEnth,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Vapor Enthalpy (kJ/kg)")
      plt.ylabel("mbsf")
      plt.xlabel("distance (km)")
      plt.colorbar(format = "%.0f")

      plt.subplot(235)
      plt.contourf(XCoords,ZCoords,LiquidDens,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Liquid Density (kg/m^3)")
      plt.xlabel("distance (km)")
      plt.colorbar(format = "%.0f")

      plt.subplot(236)
      plt.contourf(XCoords,ZCoords,VaporDens,Resolve)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(XCoords),max(XCoords)])
      plt.title("Vapor Density (kg/m^3)")
      plt.xlabel("distance (km)")
      plt.colorbar(format = "%.0f")
      plt.show()

    if (Option == 2) :
      import plotvels as pv
      reload(pv)
      pv.plotvels(XCoords,ZCoords,TempMat,Resolve)
      #pv.plotvels(XCoords,ZCoords,SaliMat,Resolve)
  else :
    if (Option == 0) :
      plt.subplot(232)
      plt.plot(TempMat,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(TempMat),max(TempMat)])
      plt.title("Temperature")
      plt.xlabel("temperature (C)")
      plt.grid()
     
      plt.subplot(231)
      plt.plot(PresMat,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(PresMat),max(PresMat)])
      plt.title("Pressure")
      plt.ylabel("mbsf")
      plt.xlabel("pressure (bars)")
      plt.grid()
     
      plt.subplot(233)
      plt.plot(SaliMat,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(SaliMat),max(SaliMat)])
      plt.title("Bulk Salinity")
      plt.xlabel("Salinity (wt% NaCl)")
      plt.grid()
     
      plt.subplot(234)
      plt.plot(LiqVols,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(LiqVols),max(LiqVols)])
      plt.title("Liquid Saturation")
      plt.ylabel("mbsf")
      plt.xlabel("liquid saturation")
      plt.grid()
     
      plt.subplot(235)
      plt.plot(DensMat,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(DensMat),max(DensMat)])
      plt.title("Bulk Density")
      plt.xlabel("density (kg/m^3)")
      plt.grid()
     
      plt.subplot(236)
      plt.plot(EnthMat,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(EnthMat),max(EnthMat)])
      plt.title("Bulk Enthalpy")
      plt.xlabel("enthalpy (kJ/kg)")
      plt.grid()
      plt.show()
    else :
      plt.subplot(241)
      plt.plot(LiquidSali,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(LiquidSali),max(LiquidSali)])
      plt.title("Liquid Salinity")
      plt.xlabel("salinity (wt% NaCl)")
      plt.ylabel("mbsf")
      plt.grid()
     
      plt.subplot(245)
      plt.plot(VaporSali,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(VaporSali),max(VaporSali)])
      plt.title("Vapor Salinity")
      plt.xlabel("salinity (wt% NaCl)")
      plt.ylabel("mbsf")
      plt.grid()
     
      plt.subplot(242)
      plt.plot(LiquidEnth,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(LiquidEnth),max(LiquidEnth)])
      plt.title("Liquid Enthalpy")
      plt.xlabel("enthalpy (kJ/kg)")
      plt.grid()
     
      plt.subplot(246)
      plt.plot(VaporEnth,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(VaporEnth),max(VaporEnth)])
      plt.title("Vapor Enthalpy")
      plt.xlabel("enthalpy (kJ/kg)")
      plt.grid()
     
      plt.subplot(247)
      plt.plot(VaporDens,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(VaporDens),max(VaporDens)])
      plt.title("Vapor Density")
      plt.xlabel("density (kg/m^3)")
      plt.grid()
      
      plt.subplot(243)
      plt.plot(LiquidDens,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(LiquidDens),max(LiquidDens)])
      plt.title("Liquid Density")
      plt.xlabel("density (kg/m^3)")
      plt.grid()
     
      plt.subplot(244)
      plt.plot(LiquidVeloc,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(LiquidVeloc),max(LiquidVeloc)])
      plt.title ("Liquid Velocity")
      plt.xlabel("velocity (cm/yr)")
      plt.grid()
      
      plt.subplot(248)
      plt.plot(VaporVeloc,ZCoords,'r',lw=2)
      plt.ylim([max(ZCoords),min(ZCoords)])
      plt.xlim([min(VaporVeloc),max(VaporVeloc)])
      plt.title ("Vapor Velocity")
      plt.xlabel("velocity (cm/yr)")
      plt.grid()
      plt.show()
