def plotvels(XCoords,ZCoords,TempMat,Resolve) :
  import numpy
  from numpy import zeros,array,loadtxt
  from pylab import loadtxt,setp
  from math import sqrt,atan2,acos
  import matplotlib
  import matplotlib.pyplot as plt
  import math

  ULiqVelComp = loadtxt("ULiqVelComp.dat")
  VLiqVelComp = loadtxt("VLiqVelComp.dat")
  UVapVelComp = loadtxt("UVapVelComp.dat")
  VVapVelComp = loadtxt("VVapVelComp.dat")

  NumNodesX = len(XCoords)
  NumNodesZ = len(ZCoords)

  ULiq = zeros((NumNodesZ,NumNodesX),numpy.float)
  UVap = zeros((NumNodesZ,NumNodesX),numpy.float)
  VLiq = zeros((NumNodesZ,NumNodesX),numpy.float)
  VVap = zeros((NumNodesZ,NumNodesX),numpy.float)
  X    = zeros((NumNodesZ,NumNodesX),numpy.float)
  Z    = zeros((NumNodesZ,NumNodesX),numpy.float)
  for i in range(0,NumNodesX) :
    for k in range(0,NumNodesZ) :
      if (i==(NumNodesX-1)) :
        ULiq[k][i]=0
        UVap[k][i]=0
      else :
        ULiq[k][i]=ULiqVelComp[k][i]
        UVap[k][i]=UVapVelComp[k][i]
      if (k==(NumNodesZ-1)) :
        VLiq[k][i]=0
        VVap[k][i]=0
      else :
        VLiq[k][i]=VLiqVelComp[i][k]
        VVap[k][i]=VVapVelComp[i][k]
      X[k][i] = XCoords[i]
      Z[k][i] = ZCoords[k]
 
  scale = numpy.max(numpy.max(VLiq))*10.0
  plt.contourf(X,Z,TempMat,Resolve)
  plt.colorbar(format = "%.1f")
  plt.quiver(X,Z,ULiq,-VLiq,color = 'k')
  plt.quiver(X,Z,UVap,-VVap,scale = scale,color = 'b')
  plt.ylim([max(ZCoords),min(ZCoords)])
  plt.xlim([min(XCoords),max(XCoords)])
  plt.title("Temperature (C) and velocity vectors")
  #plt.title("Salinity (wt% NaCl) and velocity vectors")
  plt.ylabel("mbsf")
  plt.xlabel("distance (m)")
