import numpy
from numpy import zeros,array
from pylab import load,setp
from math import sqrt,atan2,acos
import matplotlib
import matplotlib.pyplot as plt
import math

SurfTemps = load("SurfTemps.dat")
SurfSals  = load("SurfSals.dat")
Times     = load("Times.dat")

RefSals = array(len(Times)*[0.],numpy.float)
for i in range(0,len(Times)) :
  RefSals[i] = 3.2

plt.subplot(211)
plt.plot(Times,SurfSals,"ro")
plt.plot(Times,RefSals,"k-")
plt.title("Surface vent fluid temperatures (C) and salinities \
(wt% NaCl)")
plt.ylabel("salinity (wt% NaCl)")
plt.ylim([min(SurfSals),max(SurfSals)])
plt.xlim([min(Times),max(Times)])
plt.grid()
plt.subplot(212)
plt.plot(Times,SurfTemps,"ro")
plt.ylim([min(SurfTemps),max(SurfTemps)])
plt.xlim([min(Times),max(Times)])
plt.xlabel("time (yrs)")
plt.ylabel("temperature (C)")
plt.grid()
plt.show()
